﻿/* ETBinsertSymbol_de.jsx ------ UTF-8 ------------------------------------------------------------
                 Insert special symbols, selectable from list - de version
   Documentation www.daube.ch/docu/fmaker73.html
   Comment       To be placed in Startup folder of user area
   Reference     Based on SaveBookAsOldVersion 2013-09-04 by Carmen Publishing Inc. (www.frameexpert.com)
   Attention     Code must be UTF-8. With Windows cp no umlauts etc. are allowed in menu items.
   Copyleft      2017 Klaus Daube, Zürich, Switzerland, klaus@daube.ch
   History       2017-006-30 v1.0 released:
                 2018-01-16 v 1.1 New command name
*/ ; // ===========================================================================================
#target framemaker  

var gasSymbolNames = [                            // names are for german version of script
// the name and symbol are separated by a vertical bar.
    "Anführung oben 6|‘",                         // http://www.pt-mediengestaltung.de/anfuehrungszeichen.html
    "Anführung oben 66|“",
    "Anführung oben 9|’", 
    "Anführung oben 99|”",
    "Anführung oben gespiegelt 9|‛",
    "Anführung oben gespiegelt 99|‟",
    "Anführung unten 9|‚",
    "Anführung unten 99|„",
    "Copyright|©",
    "Dolch doppelt|‡",
    "Dolch einfach|†",
    "Durchmesser|⌀",                              // U+2300
    "Elipsis|…",
    "Griechisch alpha|α",
    "Griechisch beta|β",
    "Griechisch gamma|γ",
    "Griechisch pi|π",
    "Guillemet links doppelt|«",
    "Guillemet links einzeln|‹",
    "Guillemet rechts doppelt|»",
    "Guillemet rechts einzeln|›",
    "Handelsmarke|™",
    "Kugel|•",
    "Leerzeichen m| ",
    "Leerzeichen n| ",
    "Leerzeichen dünn|x12",
    "Leerzeichen geschützt|x11",
    "Leerzeichen numerisch|x10",
    "Math. Bruchstrich|⧸",                        // U+29f8
    "Math. dividieren|÷",
    "Math. Element von|∈",
    "Math. grösser gleich|≥",
    "Math. Inkrement|∆",
    "Math. Integral|∫",
    "Math. kleiner gleich|≤",
    "Math. multiplizieren|×",
    "Math. plus/minus|±",
    "Math. Summe|∑",
    "Math. unendlich|∞",
    "Öffnendes Ausrufezeichen|¡",
    "Öffnendes Fragezeichen|¿",
    "Registriert|®",
    "Strich Binde- (n)|–",                        // http://typefacts.com/artikel/grundlagen/bindestrich-gedankenstrich
    "Strich Gedanken- (m)|—",
    "Symbol Abschnitt|¶",
    "Symbol Grad|°",
    "Symbol my|µ",
    "Symbol Ohm|Ω",
    "Symbol Paragraph|§",
    "Symbol Promille|‰",
    "Trennstrich geschützt|x15",
    "Trennstrich optional|x04",
    "Trennung unterdücken|x05",
    "Viertel 1|¼",
    "Viertel 2|½",
    "Viertel 3|¾",
    "Winkel/Zeit Minute|'",
    "Winkel/Zeit Sekunde|\"",
    ]

var gsETBSymbols_symbol;
var gsETBSymbols_title = { en: "Insert Special Symbol [ETB]",
                           de: "Sonderzeichen einfügen [ETB]",
                           fr: "Enserer symboles speciales [ETB]"};
var gsETBSymbols_NoDoc = { en: "No document active",
                           de: "Kein Dokument aktiv",
                           fr: "Aucun document actif"};


SetupNotifications ();                            // notification trigger 'Change document', comment for debugging
// DialogInsertSymbol();                          // un-comment for debugging
SetUpMenu();                                      // out-comment for debugging

function DialogInsertSymbol(){ //=== Dialog to insert special symbols =============================
// Arguments -
// Returns   Inserts selected symbol into document text
// Called by main
// Calling   InsertSymbol, ToUnicode
// Reference ScriptUI for Dumies by kahrel@kahrel.plus.com (multicolumn lists)
var wDlg = new Window('dialog',"ETB Sonderzeichen einfügen",undefined);
var nItems, iTab, sName, sItem
var sInfo = "Anstelle der Auswahl in der Liste kann auch direkt ein 2-hex-Zeichen FM Code (zb ab für \xab) oder ein 4-hex-Zeichen Unicode (05d0 für \u05d0) eingegeben werden."
           +"\n\nDie Symbole Durchmesser and Math. Bruchstrich erfordern Schrift Segoe UI Symbol (oder anderes).";

	wDlg.g1 = wDlg.add('group',undefined);

  	wDlg.g1.p1 = wDlg.g1.add('panel',undefined, "Doppel-Klick für Auswahl");
    	wDlg.g1.p1.preferredSize.height = 250;
    
    	wDlg.g1.p1.SymbolNames = wDlg.g1.p1.add('listbox',undefined, undefined,{numberOfColumns: 2, showHeaders: false});                // to become two column list
    	wDlg.g1.p1.SymbolNames.graphics.font = ScriptUI.newFont ("dialog", "", 12);
    	wDlg.g1.p1.SymbolNames.size= [220,225];
  
  	wDlg.g1.p2 = wDlg.g1.add('panel',undefined,"Font Consolas, 48pt");
    	wDlg.g1.p2.preferredSize.height = 250;
    
    	wDlg.g1.p2.SymbolDisplay = wDlg.g1.p2.add('edittext',undefined,"Symbol");
    	wDlg.g1.p2.SymbolDisplay.graphics.font = ScriptUI.newFont ("Consolas", "", 48);
    	
    	wDlg.g1.p2.Info = wDlg.g1.p2.add('statictext',undefined, sInfo, {multiline:true});
      wDlg.g1.p2.Info.graphics.font = ScriptUI.newFont ("dialog", "", 12);
    
    	wDlg.g1.p2.Insert = wDlg.g1.p2.add('button',undefined,"Symbol einfügen");
// --- behaviour of edit field SymbolDisplay ------------------------------------------------------
  wDlg.g1.p2.SymbolDisplay.onChange = function () { // does this trigger if filled from list ?
    gsETBSymbols_symbol = wDlg.g1.p2.SymbolDisplay.text;
  };
// --- fill the list with items and subitems ------------------------------------------------------
  nItems = gasSymbolNames.length;
  for (j = 0; j < nItems; j++) {                  // make a 2-column list
    iTab = gasSymbolNames[j].indexOf("|");
    sName = gasSymbolNames[j].substring (0, iTab);
    sItem = gasSymbolNames[j].substring (iTab+1);
    with (wDlg.g1.p1.SymbolNames.add ("item", sName)) {
      subItems[0].text = sItem;
    } 
  }
// --- behaviour of the lists ---------------------------------------------------------------------
// onChange would require an empty element (http://stackoverflow.com/questions/11877527)
// IMHO ondoubleClick is more user friendly as it indicates an action.
  wDlg.g1.p1.SymbolNames.onDoubleClick = function () { 
  var listIndex, tmpText, strLen, sSymbol

    listIndex = wDlg.g1.p1.SymbolNames.selection.valueOf(),
    tmpText = gasSymbolNames[listIndex];          // get the last character: the symbol
    strLen = tmpText.length;
    sSymbol = tmpText.substr (strLen-1, 1);
    if (/\d/.test(sSymbol)) {                     // notation of FM functional char
      sSymbol = tmpText.substr (strLen-2, 2);
    }
    wDlg.g1.p2.SymbolDisplay.text = sSymbol;
    gsETBSymbols_symbol = sSymbol;
  };

// --- behaviour of the buttons -------------------------------------------------------------------
  wDlg.g1.p2.Insert.onClick = function () {
  var sCode, sSymbol, sUnicode, sAsci, ss

    sSymbol = gsETBSymbols_symbol;
    if (sSymbol.length > 1) {                     // direct entry in edit field
      if (sSymbol.length == 2) {                  // this is a FramMaker function, e.g. 04 (optional hyphen)
        sAsci = String.fromCharCode(parseInt(sSymbol, 16));
        InsertSymbol (sAsci);
      }
      if (sSymbol.length == 4) {                  // this is a Unicode Char, e.g. 05D0 (א Alef)
        sUnicode = ToUnicode (sSymbol)
        InsertSymbol (sUnicode);
      }
    } else {                                      // selection from list
      InsertSymbol (sSymbol);
    }
    wDlg.close();
  }
  wDlg.show();
}

function SetUpMenu() { // =========================================================================
// This function MUST NOT be named DefineMenu - because this is a reserved function!
// Errors in ESTK: Menu position can not be changed - see bug report FRMAKER-2752
// No menu is defined here - it is set up in customui.cfg / menus.cfg
  var cmdDoc = DefineCommand (1, "ETB_InsertSymbol", "Sonderzeichen einfügen [ETB]", ""); 
  UpdateMenus();
} // --- end SetUpMenu

function Command(cmd) { // ========================================================================
	switch(cmd)  {	                                // Respond to menu command.
		case 1: 
      DialogInsertSymbol();
      break;
    }
} // --- end Command

function InsertSymbol (sSymbol) { //=== Insert symbol at current text location ====================
// Arguments sSymbol:  the Unicode character to be inserted into the text
// Returns   -
// Called by DialogInsertSymbol
var oDoc, oTextRange

  oDoc = app.ActiveDoc;
  oTextRange = oDoc.TextSelection;
  oDoc.AddText(oTextRange.beg, sSymbol);          // insert the new text at the original beginning of the text range
  oTextRange.end.offset = oTextRange.beg.offset + 1; // 1character inserted
  newTextRange  = new TextRange(oTextRange.end, oTextRange.end);
  oDoc.TextSelection = newTextRange;              // place cursor behind inserted char
}

function ToUnicode (sCode) { //=== Convert unicode defintion to the character ====================
// Arguments sCode: a string of the form hhhh with h being Hex figures
// Returns   Function is the resulting Unicode chacracter 
// Called by DialogInsertSymbol
// Reference http://stackoverflow.com/questions/17267329/converting-unicode-character-to-string-format
var sCode, Unicode

  sUnicode = String.fromCharCode(parseInt(sCode,16))                     
  return sUnicode;
};

function SetupNotifications () { // Watch for the following notifications ========================= 
  Notification (Constants.FA_Note_PostActiveDocChange, true);  
} // --- end SetupNotifications

function Notify (note, object, sparam, iparam) {  // Handle triggered events ======================
  if (typeof  wDlg == "undefined") {return;}      // just started in StartUp folder
  switch (note) {
    case Constants.FA_Note_PostActiveDocChange:   // active document has changed
      if (!app.ActiveDoc.ObjectValid()) {
        alert ("ETBInsertSymbol_de: " + localize (gsETBSymbols_NoDoc));
        wDlg.close();
        return;
      } else {
//      goActiveDoc = object;
      }
    break;
    
    default:	                                    // unknown notification
  }
} // --- end Notify
